<mat-card class="p-0">
    <div class="ribbon-wrapper" *ngIf="isPaid">
        <div class="ribbon">Paid</div>
    </div>
    <mat-card-title class="mb-0 d-flex">
        <div class="add-invoice-title d-flex align-items-center justify-content-center">
            {{invoiceId?'Edit':'Add'}} Invoice
        </div>
        <div class="d-flex align-items-center flex-fill justify-content-end" style="font-size: 14px;"
            [ngStyle]="{'padding-right': isPaid ? '50px' : '20px'}">
            <label class="m-0">Outstanding Balance: </label>
            <label class="m-0 text-danger">&nbsp;$ 30</label>
        </div>
    </mat-card-title>
    <mat-divider></mat-divider>
    <mat-card-content class="invoice-card-content">
        <div>
            <form [formGroup]="invoiceForm">
                <div class="row">

                    <div class="col-sm-4" *ngIf="isBillingPage">
                        <mat-form-field [appearance]="'outline'" class="full-width mr-2">
                            <mat-label>Select Patient</mat-label>
                            <app-dropdown-search [data]="allPatientList" valueField="id" textField="fullNameWithTitle"
                                formControlName="patientId" (valueChange)="onChangePatient($event)">
                            </app-dropdown-search>
                            <mat-error *ngIf="invoiceForm.get('patientId').hasError('required')">
                                This field is required
                            </mat-error>
                        </mat-form-field>
                    </div>

                    <div class="col-sm-4" *ngIf="isBillingPage">
                        <mat-form-field [appearance]="'outline'" class="full-width mr-2">
                            <mat-label>Related Appointment</mat-label>
                            <app-dropdown-search [data]="selectedPatientAppointments" valueField="id"
                                textField="startDateUTC" formControlName="appointmentsEntryId">
                            </app-dropdown-search>
                            <mat-error *ngIf="invoiceForm.get('appointmentsEntryId').hasError('required')">
                                This field is required
                            </mat-error>
                        </mat-form-field>
                    </div>

                    <div class="col-sm-4">
                        <mat-form-field [appearance]="'outline'" class="full-width mr-2">
                            <mat-label>Invoices Date</mat-label>
                            <app-date-picker formControlName="invoiceDate"></app-date-picker>
                            <mat-error *ngIf="invoiceForm.get('invoiceDate').hasError('required')">
                                This field is required
                            </mat-error>
                        </mat-form-field>
                    </div>

                    <div class="col-sm-4">
                        <mat-form-field [appearance]="'outline'" class="full-width mr-2">
                            <mat-label>Bill To</mat-label>
                            <app-dropdown-search formControlName="billTo" [data]="allBillTo" valueField="id"
                                textField="name"></app-dropdown-search>
                            <mat-error *ngIf="invoiceForm.get('billTo').hasError('required')">
                                This field is required
                            </mat-error>
                        </mat-form-field>
                    </div>

                    <div class="col-sm-4">
                        <mat-form-field [appearance]="'outline'" class="full-width mr-2">
                            <mat-label>Practitioner</mat-label>
                            <app-dropdown-search formControlName="practitionerId" [data]="allPractitioners"
                                valueField="id" textField="patientSearchName"></app-dropdown-search>
                            <mat-error *ngIf="invoiceForm.get('practitionerId').hasError('required')">
                                This field is required
                            </mat-error>
                        </mat-form-field>
                    </div>

                    <div class="col-sm-4">
                        <mat-form-field [appearance]="'outline'" class="full-width mr-2">
                            <mat-label>Case</mat-label>
                            <app-dropdown-search formControlName="caseId" [data]="selectedPatientCases" valueField="id"
                                textField="caseName"></app-dropdown-search>
                            <mat-error *ngIf="invoiceForm.get('caseId').hasError('required')">
                                This field is required
                            </mat-error>
                        </mat-form-field>
                    </div>

                    <div class="col-sm-4">
                        <mat-form-field [appearance]="'outline'" class="full-width mr-2">
                            <mat-label>Payer</mat-label>
                            <app-dropdown-search formControlName="payerId" [data]="selectedCasePayers" valueField="id"
                                textField="name"></app-dropdown-search>
                            <mat-error *ngIf="invoiceForm.get('payerId').hasError('required')">
                                This field is required
                            </mat-error>
                        </mat-form-field>
                    </div>

                    <div class="col-sm-4">
                        <mat-form-field [appearance]="'outline'" class="full-width mr-2">
                            <mat-label>Referral</mat-label>
                            <app-dropdown-search [data]="selectedCaseReferrals" valueField="id" textField="name"
                                formControlName="referralId"></app-dropdown-search>
                            <mat-error *ngIf="invoiceForm.get('referralId').hasError('required')">
                                This field is required
                            </mat-error>
                        </mat-form-field>
                    </div>

                    <div class="col-sm-4">
                        <mat-form-field [appearance]="'outline'" class="full-width mr-2">
                            <mat-label>Concession</mat-label>
                            <app-dropdown-search [data]="allConcessions" formControlName="concessionId" valueField="id"
                                textField="concessionType"></app-dropdown-search>
                            <mat-error *ngIf="invoiceForm.get('concessionId').hasError('required')">
                                This field is required
                            </mat-error>
                        </mat-form-field>
                    </div>
                </div>

            </form>
        </div>

        <mat-divider></mat-divider>

        <!-- Invoice Items -->
        <div class="add-invoice-invoice-item" style="margin-top: 20px;">

            <div class="card-title-wrapper">
                <label class="m-0 font-weight-bold normal_16px_22px_font">Invoice Item</label>
            </div>

            <div style="margin-top: 28px;">

                <kendo-grid #grid class="reminder-settings-grid separator border" [data]="gridView"
                    [pageSize]="pageSize" [skip]="skip" [pageable]="true" [columnMenu]="false"
                    (dataStateChange)="dataStateChange($event)" [groupable]="false" [reorderable]="reorder"
                    [sort]="sort" (sortChange)="sortChange($event)" (groupChange)="groupChange($event)" [sortable]="{
                    allowUnsort: allowUnsort,
                    mode: multiple ? 'multiple' : 'single'
                }" [selectable]="{
                                            checkboxOnly: true,
                                            mode: 'multiple'
                                        }" [filterable]="false" [filter]="state.filter" [style.height.%]="100"
                    [kendoGridSelectBy]="'index'" [scrollable]="'scrollable'" (drop)="onDrop($event)"
                    (dragover)="onDragOver($event)">

                    <kendo-grid-column [width]="40" [style]="{minWidth: '20px'}">
                        <ng-template kendoGridCellTemplate let-dataItem let-rowIndex="rowIndex">
                            <mat-icon draggable="true" (dragstart)="onDragStart($event, rowIndex)">drag_indicator
                            </mat-icon>
                        </ng-template>
                    </kendo-grid-column>

                    <kendo-grid-column field="staffId" title="Sales Staff" [width]="180">
                        <ng-template kendoGridCellTemplate let-dataItem let-column="column">
                            <mat-form-field class="rs-mat-field mat-field-table" appearance="outline">
                                <app-dropdown-search [data]="allStaffs" valueField="id" textField="name"
                                    [formControl]="getFormControl(dataItem, 'staffId')">
                                </app-dropdown-search>
                                <mat-error *ngIf="getFormControl(dataItem, 'staffId').hasError('required')">
                                    This field is required
                                </mat-error>
                            </mat-form-field>
                        </ng-template>
                    </kendo-grid-column>

                    <kendo-grid-column field="offeringId" title="Offerings" [width]="245">
                        <ng-template kendoGridCellTemplate let-dataItem let-column="column" let-index="index">
                            <mat-form-field class="rs-mat-field mat-field-table" appearance="outline">
                                <app-dropdown-tree-view [data]="allOfferings" textField="name" valueField="id"
                                    [formControl]="getFormControl(dataItem, 'offeringId')"
                                    (valueChange)="onSelectOffering($event, index, dataItem)">
                                </app-dropdown-tree-view>

                                <!-- <kendo-dropdowntree #dTreeView
                                kendoDropDownTreeExpandable
                                [kendoDropDownTreeFlatBinding]="allOfferings"
                                parentIdField="reportsTo"
                                valueField="id"
                                textField="name"
                                [value]="dataItem['offer']"
                                [formControl]="getFormControl(dataItem, 'offeringId')"
                                class="furniture"
                                [popupSettings]="{popupClass: 'app-kdt-popup'}"
                              >
                              </kendo-dropdowntree> -->

                                <!-- <app-dropdown-search [data]="allOfferings" valueField="id" textField="name"
                                    [formControl]="getFormControl(dataItem, 'offeringId')"
                                    (valueChange)="onSelectOffering($event, index, dataItem)">
                                </app-dropdown-search> -->
                                <mat-error *ngIf="getFormControl(dataItem, 'offeringId').hasError('required')">
                                    This field is required
                                </mat-error>

                            </mat-form-field>
                        </ng-template>
                    </kendo-grid-column>

                    <kendo-grid-column field="fees" title="Fee" [width]="80">
                        <ng-template kendoGridCellTemplate let-dataItem let-column="column" let-index="index">
                            <mat-form-field class="rs-mat-field mat-field-table" appearance="outline">
                                <input matInput type="text" [formControl]="getFormControl(dataItem, 'fees')"
                                    (blur)="onChangeFee($event, dataItem)" appCharLimit max="30"
                                     />
                                <mat-error *ngIf="getFormControl(dataItem, 'fees').hasError('required')">
                                    This field is required
                                </mat-error>
                            </mat-form-field>
                        </ng-template>
                    </kendo-grid-column>

                    <kendo-grid-column field="qtyOrDuration" title="Qty/Duration" [width]="100">
                        <ng-template kendoGridCellTemplate let-dataItem let-column="column" let-index="index">
                            <mat-form-field class="rs-mat-field mat-field-table" appearance="outline">
                                <input matInput type="text" [formControl]="getFormControl(dataItem, 'qtyOrDuration')"
                                    (blur)="onChangeQty($event, dataItem)" appCharLimit max="30"
                                    [fc]="getFormControl(dataItem,'qtyOrDuration')" />
                                <mat-error *ngIf="getFormControl(dataItem, 'qtyOrDuration').hasError('required')">
                                    This field is required
                                </mat-error>
                            </mat-form-field>
                        </ng-template>
                    </kendo-grid-column>

                    <kendo-grid-column field="discount" title="Discount" [width]="100">
                        <ng-template kendoGridCellTemplate let-dataItem let-column="column" let-index="index">
                            <mat-form-field class="rs-mat-field mat-field-table" appearance="outline">
                                <app-dropdown-search [data]="allDiscountTypes" valueField="discountAmount"
                                    textField="discountName" (valueChange)="onSelectDiscount($event, index, dataItem)"
                                    [formControl]="getFormControl(dataItem, 'discount')">
                                </app-dropdown-search>
                            </mat-form-field>
                        </ng-template>
                    </kendo-grid-column>

                    <kendo-grid-column field="taxRate" title="Tax Rate" [width]="100">
                        <ng-template kendoGridCellTemplate let-dataItem let-column="column">
                            $ {{dataItem.taxRate}}
                        </ng-template>
                    </kendo-grid-column>

                    <kendo-grid-column field="amount" title="Amount" [width]="100">
                        <ng-template kendoGridCellTemplate let-dataItem let-column="column">
                            $ {{dataItem.amount}}
                        </ng-template>
                    </kendo-grid-column>

                    <kendo-grid-column field="due" title="Due" [width]="100">
                        <ng-template kendoGridCellTemplate let-dataItem let-column="column">
                            <mat-form-field class="rs-mat-field mat-field-table" appearance="outline">
                                <input matInput type="text" [formControl]="getFormControl(dataItem, 'due')" appCharLimit
                                    max="30" [fc]="getFormControl(dataItem,'due')" />
                            </mat-form-field>
                        </ng-template>
                    </kendo-grid-column>

                    <!-- <kendo-grid-column title="Pay" [width]="40">
                        <ng-template kendoGridCellTemplate let-dataItem let-column="column">
                            <button class="item-setting-btn border-0 bg-transparent cursor-pointer">
                                <mat-icon class="m-0" style="color: #979797;">attach_money</mat-icon>
                            </button>
                        </ng-template>
                    </kendo-grid-column> -->

                    <kendo-grid-column title="Action" [width]="90">
                        <ng-template kendoGridCellTemplate let-dataItems>
                            <button matTooltip="Add" (click)="addInvoiceItem(dataItems.index + 1)"
                                class="item-setting-btn border-0 bg-transparent cursor-pointer">
                                <mat-icon class="m-0 text-primary">add</mat-icon>
                            </button>
                            <button *ngIf="gridView.total > 1" matTooltip="Remove" (click)="deleteRow(dataItems.index)"
                                class="ml-2item-setting-btn border-0 bg-transparent cursor-pointer">
                                <mat-icon class="m-0 text-danger">delete</mat-icon>
                            </button>
                        </ng-template>
                    </kendo-grid-column>
                </kendo-grid>

            </div>

        </div>

        <!-- Invoice Total -->
        <div class="d-flex justify-content-end" style="margin-top: 30px;">

            <div class="flex-fill mr-4" [formGroup]="invoiceForm">


                <div class="payment-history mb-2" style="max-width: 700px;">
                    <div class="card-title-wrapper mb-3">
                        <label class="m-0 font-weight-bold normal_16px_22px_font">Payment History</label>
                    </div>


                    <kendo-grid class="reminder-settings-grid border" [pageable]="false">

                        <kendo-grid-column field="paymentNo" title="Payment No" [width]="50">
                            <ng-template kendoGridCellTemplate let-dataItem let-rowIndex="rowIndex">
                                {{dataItem.paymentNo}}
                            </ng-template>
                        </kendo-grid-column>

                        <kendo-grid-column field="date" title="Payment Date" [width]="70">
                            <ng-template kendoGridCellTemplate let-dataItem let-column="column">
                                {{ dataItem.payDate | date }}
                            </ng-template>
                        </kendo-grid-column>

                        <kendo-grid-column field="amount" title="Payment Amount" [width]="70">
                            <ng-template kendoGridCellTemplate let-dataItem let-column="column">
                                ${{dataItem.amount}}
                            </ng-template>
                        </kendo-grid-column>

                        <kendo-grid-column field="notes" title="Notes" [width]="100">
                            <ng-template kendoGridCellTemplate let-dataItem let-column="column">
                                {{dataItem.notes}}
                            </ng-template>
                        </kendo-grid-column>

                        <kendo-grid-column title="Action" [width]="50">
                            <ng-template kendoGridCellTemplate let-dataItems>
                                <a matTooltip="Edit" [routerLink]="'edit/'+dataItems.invoiceId"
                                    class="item-setting-btn border-0 bg-transparent cursor-pointer">
                                    <mat-icon class="m-0 text-primary">edit</mat-icon>
                                </a>
                                <a matTooltip="Delete"
                                    class="ml-2 item-setting-btn border-0 bg-transparent cursor-pointer">
                                    <mat-icon class="m-0 text-danger">delete</mat-icon>
                                </a>
                            </ng-template>
                        </kendo-grid-column>

                    </kendo-grid>
                </div>

                <div class="card-title-wrapper mb-3 mt-2">
                    <label class="m-0 font-weight-bold normal_16px_22px_font">Additional Information</label>
                </div>

                <mat-form-field appearance="outline" style="max-width: 700px;">
                    <mat-label>Invoice Notes</mat-label>
                    <textarea matInput formControlName="notes" rows="5"></textarea>
                </mat-form-field>

            </div>

            <div>

                <div class="d-flex flex-column" style="gap: 10px;">

                    <div class="invoice-total-wrapper">
                        <div>Sub Total</div>
                        <div>$ {{subTotal}}</div>
                    </div>

                    <div class="invoice-total-wrapper">
                        <div>Discount Value</div>
                        <div>$ {{discount}}</div>
                    </div>

                    <div class="invoice-total-wrapper">
                        <div>Tax</div>
                        <div>$ {{tax}}</div>
                    </div>

                    <div class="invoice-total-wrapper total">
                        <div>Total</div>
                        <div>$ {{invoiceForm.get('totalAmount').value}}</div>
                    </div>

                </div>

                <div class="text-right" style="margin-top: 10px;">
                    <button mat-raised-button *ngIf="!isPaid" (click)="openPaymentpopup()">Full Payment</button>
                </div>
            </div>

        </div>

        <div class="d-flex justify-content-end">
            <div class="flex-fill">
                <div class="deletebutton">
                    <button *ngIf="invoiceId && !isPaid" (click)="oepnDeletPopup()" mat-raised-button
                        class="deletebutton-wrapper custom-delete-btn ml-2" color="accent">
                        Delete
                    </button>
                </div>
            </div>
            <button mat-stroked-button (click)="back()">Cancel</button>
            <button mat-stroked-button class="ml-2" (click)="saveOrUpdateInvoice()">{{invoiceId?'Update':'Save'}} &
                Email</button>
            <button mat-stroked-button class="ml-2" (click)="saveOrUpdateInvoice()">{{invoiceId?'Update':'Save'}} &
                Print</button>
            <button mat-raised-button class="ml-2"
                (click)="saveOrUpdateInvoice()">{{invoiceId?'Update':'Save'}}</button>
        </div>
    </mat-card-content>

</mat-card>